=== docs/requirements.txt ===
sphinx>=2.0.0
sphinx-rtd-theme>=0.4.3
sphinxcontrib-plantuml>=0.15
