=== debian/changelog ===
arm-trusted-firmware (2.4+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vagrant Cascadian <vagrant@debian.org>  Sat, 16 Jan 2021 17:29:49 -0800

arm-trusted-firmware (2.4+dfsg-1) experimental; urgency=medium

  [ Vagrant Cascadian ]
  * debian/targets: Enable g12a target (Closes: #973255).
  * Enable Build-Profile pkg.arm-trusted-firmware.notools to disable
    building of arm-trusted-firmware-tools.
  * debian/targets: Enable sun50i_h6 target (Closes: #979179).

  [ Nicolas Boulenguez ]
  * Update debian/watch (Closes: #977803).
  * Delegate changelog renaming to debhelper (Closes: #977803).
  * Let dh_auto_build call sub-Makes (Closes: #977803).

  [ Vagrant Cascadian ]
  * arm-trusted-firmware: Update lintian overrides to use a glob. Thanks
    to Nicolas Boulenguez.  (Closes: #977803)
  * debian/control: Update Standards-Version to 4.5.1.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 04 Jan 2021 13:40:33 -0800

arm-trusted-firmware (2.3+dfsg-3) unstable; urgency=medium

  * Only build firmware on arm64.
  * Pass empty CFLAGS and LDFLAGS to firmware build
  * Pass CFLAGS and CPPFLAGS to fiptool and cert_create.
  * Drop hardening options that no longer cause issues for the firmware
    build.
  * Drop --debug flag from make invocation.
  * Use -ffile-prefix-map in TF_CFLAGS for reproducible builds.
  * Drop -fno-pie from TF_CFLAGS as it is handled upstream.

 -- Vagrant Cascadian <vagrant@debian.org>  Sat, 17 Oct 2020 22:17:48 -0700

arm-trusted-firmware (2.3+dfsg-2) experimental; urgency=medium

  * debian/control: arm-trusted-firmware: Remove description comparing to
    Intel ME. Thanks to Pali Rohár.
  * debian/control: Update to debhelper-compat 13.
  * debian/rules: Make builds verbose by default, respecting
    DEB_BUILD_OPTIONS=terse.
  * Add arm-trusted-firmware-tools (Closes: #931397). Thanks to Ying-Chun
    Liu (PaulLiu).

 -- Vagrant Cascadian <vagrant@debian.org>  Sat, 10 Oct 2020 19:22:41 -0700
