=== debian/control ===
--- 
+++ 
@@ -4,17 +4,17 @@
 Maintainer: Vagrant Cascadian <vagrant@debian.org>
 Standards-Version: 4.5.1
 Build-Depends: debhelper-compat (= 13),
- gcc-arm-none-eabi [arm64],
- binutils-arm-none-eabi [arm64],
+ gcc-arm-none-eabi:native [arm64],
+ binutils-arm-none-eabi:native [arm64],
  libssl-dev <!pkg.arm-trusted-firmware.notools>,
 Rules-Requires-Root: no
 Homepage: https://www.trustedfirmware.org/
 Vcs-Browser: https://salsa.debian.org/debian/arm-trusted-firmware
-Vcs-Git: https://salsa.debian.org/debian/arm-trusted-firmware.git -b debian/master
+Vcs-Git: https://salsa.debian.org/debian/arm-trusted-firmware.git
 
 Package: arm-trusted-firmware
 Architecture: arm64
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}
 Breaks: u-boot-rockchip (<< 2020.01~rc5)
 Description: "secure world" software for ARM SoCs - firmware
  The "secure world" on arm64 machines is a special level of CPU
