=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Vagrant Cascadian <vagrant@debian.org>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Build-Depends: debhelper-compat (= 13),
- gcc-arm-none-eabi:native [arm64],
- binutils-arm-none-eabi:native [arm64],
+ gcc-arm-none-eabi [arm64],
+ binutils-arm-none-eabi [arm64],
  libssl-dev <!pkg.arm-trusted-firmware.notools>,
 Rules-Requires-Root: no
 Homepage: https://www.trustedfirmware.org/
