=== debian/rules ===
--- 
+++ 
@@ -35,5 +35,5 @@
 endif
 
 override_dh_installchangelogs:
-	dh_installchangelogs -parm-trusted-firmware docs/change-log.rst
+	dh_installchangelogs -parm-trusted-firmware docs/change-log.md
 	dh_installchangelogs -parm-trusted-firmware-tools
